/***********************************************************
	gmaze.c -- H
***********************************************************/
#include <time.h>
#include "grwin.c"

#define COL  80  /* H̉̑傫 () */
#define ROW  48  /* H̏c̑傫 () */
#define MAXSITE  (COL * ROW / 4)  /* őTCg */
char map[COL + 1][ROW + 1];       /* n} */
int nsite = 0;                      /* o^TCg */
int xx[MAXSITE], yy[MAXSITE];       /* o^TCgW */
int dx[4] = { 2, 0, -2,  0 };       /* ψʃxNg */
int dy[4] = { 0, 2,  0, -2 };       /* ψʃxNg */
int dirtable[24][4] = {             /* \ */
	0,1,2,3, 0,1,3,2, 0,2,1,3, 0,2,3,1, 0,3,1,2, 0,3,2,1,
	1,0,2,3, 1,0,3,2, 1,2,0,3, 1,2,3,0, 1,3,0,2, 1,3,2,0,
	2,0,1,3, 2,0,3,1, 2,1,0,3, 2,1,3,0, 2,3,0,1, 2,3,1,0,
	3,0,1,2, 3,0,2,1, 3,1,0,2, 3,1,2,0, 3,2,0,1, 3,2,1,0 };

void
box(int x, int y, unsigned int color)
{
	int i;
	if((x >= 2) && (x <= COL - 2) && (y >= 2) && (y <= ROW - 2)) {
		for(i = 0; i < 8; i++) {
			int j;
			for(j = 0; j < 8; j++) {
				gr_dot(x * 8 + j, y * 8 + i, color);
			}
		}
	}
}

void
add(int i, int j)
{
	xx[nsite] = i;  yy[nsite] = j;  nsite++;
}

int
mselect(int *i, int *j)
{
	int r;

	if (nsite == 0) return 0;  /* TCgs */
	nsite--;  r = (int)(nsite * (rand() / (RAND_MAX + 1.0)));
	*i = xx[r];  xx[r] = xx[nsite];
	*j = yy[r];  yy[r] = yy[nsite];  return 1;  /*  */
}

int
main(void)
{
	int i, j, i1, j1, d, t, *tt;

	srand((unsigned)time(NULL));  /* ŗ */
	gr_on();
	for (i = 0; i <= COL; i++) {   /* n} */
		for (j = 0; j <= ROW; j++) {
			map[i][j] = 1;
			box(i, j, WHITE);
		}
	}
	for (i = 3; i <= COL - 3; i++) {
		for (j = 3; j <= ROW - 3; j++) {
			map[i][j] = 0;
			box(i, j, BLACK);
		}
	}
	map[2][3] = 0;  map[COL - 2][ROW - 3] = 0;
	box(2, 3, BLACK); box(COL - 2, ROW - 3, BLACK);
	for (i = 4; i <= COL - 4; i += 2) {  /* TCg */
		add(i, 2);  add(i, ROW - 2);
	}
	for (j = 4; j <= ROW - 4; j += 2) {
		add(2, j);  add(COL - 2, j);
	}
	while (mselect(&i, &j)) {  /* TCgI */
		for ( ; ; ) {         /* 牄΂Ă */
			tt = dirtable[(int)(24 * (rand() / (RAND_MAX + 1.0)))];
			for (d = 3; d >= 0; d--) {
				t = tt[d];  i1 = i + dx[t];  j1 = j + dy[t];
				if (map[i1][j1] == 0) break;
			}
			if (d < 0) break;
			map[(i + i1) / 2][(j + j1) / 2] = 1;
			box((i + i1) / 2, (j + j1) / 2, WHITE);
			i = i1;  j = j1;  map[i][j] = 1;  add(i, j);
			box(i, j, WHITE);
		}
	}

	hitanykey();

	return EXIT_SUCCESS;
}
